world
	mob=/mob/player
	hub="Jp.GameInADay2007"
	view=7
	version=4
	name="Ragnarok"

var
	const
		TYPE_FIRE="fire"
		TYPE_ICE="ice"
		TYPE_NORMAL="normal"

	client/acting
	list/players=list()
	player_up_to=0
	running=0

proc
	NotReady(list/l)
		for(var/client/k in l) if(!k.isReady()) return TRUE
		return FALSE

	start_game(n)
		running=1
		var/i=pick('muspelheim.dmi','niflheim.dmi')
		for(var/turf/t) t.icon=i
		players=list()
		var/list/clients=list()
		for(var/client/c) if(!c.afk) clients+=c

		var/num=1

		while(num<=n)
			if(clients.len<=0) break
			var/client/c = pick(clients)
			clients-=c
			players+=c
			c.ready=0

			spawn() c.initialise(num)
			num++

		while(num<=n)
			var/botplayer/b = new /botplayer
			players+=b
			b.initialise(num++)

		clients << "You didn't get in the game this time."

		player_up_to=rand(0, players.len-1)
		while(NotReady(players)) sleep(10)
		world << "Game started!"
		next_turn()

	end_game()
		players=list()
		player_up_to=0
		acting=null
		for(var/mob/unit/u) del u
		for(var/obj/effect/e) del e
		for(var/obj/button/b) del b
		running=0
		for(var/mob/player/p) p.del_cursor()

	next_turn()
		acting=getNextPlayer()
		var/end=1
		for(var/client/c in players) if(!c.afk) end=0
		if(players.len==1||end)
			if(acting&&!end)
				world << "We have a winner!"
				world << "[acting.key] has proven victorious!"
			else
				world << "All the paticipants have left"
			end_game()
			return

		if(!acting)
			players-=acting
			go_back()
			next_turn()

		var/list/l = acting.get_units()
		if(l.len<=0)
			world << "[acting.key] has been eliminated!"
			players-=acting
			go_back()
			next_turn()

		world << "[acting.key]'s turn"

		acting.your_turn()

	go_back()
		player_up_to--
		if(player_up_to<0) player_up_to+=players.len

	getNextPlayer()
		player_up_to=(++player_up_to)%players.len
		return players[player_up_to+1]

	get_path(mob/unit/u1, mob/unit/u2)
		return AStar(u1.loc, u2.loc, /atom/proc/cardinal_nodense, /atom/proc/distance,,,,get_dist(u1,u2))

	get_diamond(atom/centre, size, dense=0, ignore_mobs=0)
		.=list()

		var/list/check=list()
		if(isturf(centre)) check+=centre
		else check+=centre.loc

		for(var/i=1, i<=size, i++)
			for(var/turf/t in check)
				for(var/turf/t2 in t.cardinal())
					if(!(t2 in .) && (!dense||t2.Enter(centre)||(ignore_mobs&&t2.hasDenseMob()&&!t2.density)))
						.+=t2
						if(isturf(t2)) .+=t2.contents
						check+=t2
				check-=t

	get_vdiamond(atom/centre, size, dense=0, ignore_mobs=0)
		.=list()

		var/list/check=list()
		if(isturf(centre)) check+=centre
		else check+=centre.loc

		var/list/v=view(centre, size)

		for(var/i=1, i<=size, i++)
			for(var/turf/t in check)
				for(var/turf/t2 in t.cardinal())
					if((t2 in v) && !(t2 in .) && (!dense||t2.Enter(centre)||(ignore_mobs&&t2.hasDenseMob())))
						.+=t2
						if(isturf(t2)) .+=t2.contents
						check+=t2
				check-=t

	is_diagonal(n)
		return n&(n-1)

	getClosestEnemyUnit(var/mob/unit/u)
		var/mob/unit/best=null
		var/bestdist=9999999

		for(var/mob/unit/t)
			if(t.owner==u.owner) continue
			if(get_dist(t,u)<bestdist)
				best=t
				bestdist=get_dist(t,u)

		return best

	getClosestSquare(var/list/turf/turfs, var/mob/unit/u, var/mob/unit/ta)
		var/list/l = get_path(u, ta)
		for(var/turf/t in l) if((t in turfs) && !(locate(/mob/unit) in t)) return t

	make_faction_units(faction, n, client/c)
		var/list/units=list()
		switch(faction)
			if("Human")
				units+=/mob/unit/warrior
				units+=/mob/unit/warrior
				units+=/mob/unit/warrior
				units+=/mob/unit/archer
				units+=/mob/unit/archer
				units+=/mob/unit/fire_wizard
				units+=/mob/unit/ice_wizard
				units+=/mob/unit/fire_elemental
				units+=/mob/unit/ice_elemental

			if("Fire Giant")
				units+=/mob/unit/dancing_flame
				units+=/mob/unit/dancing_flame
				units+=/mob/unit/dancing_flame
				units+=/mob/unit/fire_elemental
				units+=/mob/unit/fire_elemental
				units+=/mob/unit/fire_giant
				units+=/mob/unit/fire_giant

			if("Ice Giant")
				units+=/mob/unit/giant_wolf
				units+=/mob/unit/giant_wolf
				units+=/mob/unit/giant_wolf
				units+=/mob/unit/ice_elemental
				units+=/mob/unit/ice_elemental
				units+=/mob/unit/ice_giant
				units+=/mob/unit/ice_giant

		for(var/k in units)
			var/mob/unit/u=new k(n)
			u.owner=c

atom
	proc
		cardinal()
			.=list()
			for(var/turf/t in orange(1, src)) if(!is_diagonal(get_dir(src, t))) .+=t

		cardinal_nodense()
			.=list()
			for(var/turf/t in orange(1, src)) if(!t.density && !is_diagonal(get_dir(src, t))) .+=t

		distance(atom/a)
			return abs(x-a.x)+abs(y-a.y)

obj
	effect
		icon='effect.dmi'
		mouse_opacity=0
		layer=FLY_LAYER

		blue
			icon_state="blue"

		red
			icon_state="red"

	button
		icon='buttons.dmi'
		New()
			icon_state=name

		cancel
			screen_loc="NORTH+1, EAST-2"
		end_turn
			screen_loc="NORTH+1, EAST"
		command
			var
				command
				single

			move
				command="Move"
				screen_loc="NORTH+1, WEST+2"

			attack
				command="Attack"
				screen_loc="NORTH+1, WEST+4"

			reset
				command="Reset"
				single=TRUE
				screen_loc="NORTH+1, WEST"

turf
	icon='niflheim.dmi'
	icon_state="ground"

	proc
		hasDenseMob()
			.=0
			for(var/mob/m in src) .|=m.density

	start
		icon_state="start"
		var/snum=1
		name="ground"
		New()
			.=..()
			icon_state="ground"
		start2
			snum=2

		start3
			snum=3

		start4
			snum=4

	wall
		icon_state="wall"
		density=1