client
	var
		mob/unit/selected
		obj/button/command/command
		tmp/list/mrange=list()
		afk=0
		ready=0
	Del()
		if(running&&acting&&acting==src) end_turn()
		for(var/mob/unit/u in get_units()) u.death()
		.=..()

	New()
		if(running)	src << "The game has started already. You won't be able to participate until the next one"
		edge_limit="SOUTHWEST to NORTHEAST"
		perspective |= EDGE_PERSPECTIVE
		.=..()

	Click(atom/a)
		if(src!=acting) return
		if(istype(a, /obj/button/cancel))
			cancel()
			return

		if(istype(a, /obj/button/end_turn))
			end_turn()
			return

		if(!selected)
			if(istype(a, /mob/unit) && a:owner==src)
				selected=a
				if(command && command.single) call(src, "command"+command.command)(selected)
				drawRange()
				return

		if(istype(a, /obj/button/command))
			command=a
			if(selected && command.single) call(src, "command"+command.command)(selected)
			return

		if(selected && command)
			call(src, "command"+command.command)(selected, a)

	proc
		isReady()
			return ready

		commandAttack(mob/unit/a, mob/unit/d)
			if(istype(d, /mob/unit) && a.canAttack(d))
				if(alert(src, "Are you sure you want to attack?\nDamage: [max(0, a.attack-d.defence)]  Hit: [100*(a.agility/d.agility)]  Crit: [6.25*(a.agility/d.agility)]", "Are you sure?", "Yes", "No")=="Yes") a.attack(d)
			cancel()

		commandMove(mob/unit/a, turf/t)
			if(!istype(t, /turf)||a.moved)
				cancel()
				return

			if(t in a.generateMoveRange()) a.Move(t)
			cancel()

		commandReset(mob/unit/a)
			if(!a.attacked&&a.origloc)
				a.loc=a.origloc
				a.moved=FALSE
			cancel()

		cancel()
			selected=null
			command=null
			for(var/obj/o in mrange) del o
			mrange=list()

		drawRange()
			if(!selected) return

			for(var/turf/t in selected.generateMoveRange()) mrange+=new /obj/effect/blue(t)
			for(var/turf/t in selected.generateAttackRange()-selected.generateMoveRange()) mrange+=new /obj/effect/red(t)

		end_turn()
			cancel()
			for(var/mob/unit/u in get_units()) u.reset()
			next_turn()

		get_units()
			.=list()
			for(var/mob/unit/u) if(u.owner==src) .+=u

		initialise(var/n)
			src << "You enter the battlefield, as player number [n]"
			screen+=new /obj/button/command/move
			screen+=new /obj/button/command/attack
			screen+=new /obj/button/command/reset
			screen+=new /obj/button/end_turn
			screen+=new /obj/button/cancel

			var/faction=input(src, "Which faction would you like to play as?", "Factions") in list("Human", "Fire Giant", "Ice Giant")

			make_faction_units(faction, n, src)

			mob:make_cursor()
			ready=1

		your_turn()
			src << "It's your turn!"
			if(afk)
				src << "AFK, turn skipped"
				end_turn()

mob
	animate_movement=0
	player
		density=0
		var/image/cursor
		mouse_opacity=0
		Stat()
			if(running)
				statpanel("Selection")
				if(client.selected)
					stat(client.selected)
					stat("[client.selected.hp] / [client.selected.maxhp]")
					stat("Location: ([client.selected.x], [client.selected.y])")
				if(client.command) stat("Command: ", client.command)

			if(loc && running)
				statpanel("Cursor")
				if(acting) stat("Turn: [acting.key]")
				stat("Location: ([x], [y])")
				stat("Terrain: [loc.name]", loc)
				var/mstring=""
				if(loc.density) mstring+="dense "
				if(loc.opacity) mstring+="opaque"
				if(mstring) stat(mstring)
				var/mob/unit/u = locate(/mob/unit) in loc
				if(u&&u.owner)
					stat("Unit: [u.name], belonging to [u.owner.key]", u)
					stat("[u.hp] / [u.maxhp]")
					stat("Attack: [u.attack] Defence: [u.defence]")
					stat("Agility: [u.agility] Move: [u.move]")
					stat("Range: [u.arange] Damage type: [u.dtype]")

			statpanel("Players")
			for(var/client/c)
				if(!c.afk) stat(c.key)
				else stat("[c.key] AFK")

		Login()
			.=..()
			if(!world.host || ckey==ckey(world.host)) verbs+=/mob/player/host/verb/Start
			make_cursor()

		proc
			make_cursor()
				cursor=image('effect.dmi', src, "cursor")
				src << cursor

			del_cursor()
			//	cursor=null

		verb
			Say(t as text)
				set name=">"
				set hidden=1
				world << "<font color=#f00><b>[key]:</b></font> [html_encode(t)]"

			AFK()
				client.afk=!client.afk
				if(client.afk && acting==client) client.end_turn()

			move()
				set hidden=1
				client.Click(locate(/obj/button/command/move))

			attack()
				set hidden=1
				client.Click(locate(/obj/button/command/attack))

			reset()
				set hidden=1
				client.Click(locate(/obj/button/command/reset))

			cancel()
				set hidden=1
				client.Click(locate(/obj/button/cancel))

			end_turn()
				set hidden=1
				client.Click(locate(/obj/button/end_turn))

			help()
				set hidden=1
				usr << browse(file2text('help.html'), "window=help")

		host
			verb
				Start(n as num)
					n=max(2,min(4, n))
					if(!running) start_game(n)