mob
	unit
		icon='units.dmi'
		mouse_opacity=2
		var
			hp
			maxhp

			attack
			defence
			agility

			move

			fireres
			iceres

			dtype
			arange

			client
				owner

			oldicon
			projectile

			tmp
				turf
					origloc
				moved=FALSE
				attacked

		Move()
			if(moved) return FALSE
			origloc=loc
			.=..()
			moved=.
			displayFinished()

		New(var/n)
			.=..()
			for(var/turf/start/s)
				if(s.snum==n)
					if(s.Enter(src)&&!(locate(/mob/unit) in s))
						loc=s
						return .

		proc
			canAttack(mob/unit/d)
				if(loc.density) return FALSE
				if(d in get_vdiamond(src, arange)) return TRUE
				return FALSE

			generateMoveRange()
				if(moved) return list()
				return get_diamond(src, move, TRUE)-loc

			generateAttackRange()
				if(attacked) return list()
				return get_diamond(src, arange, TRUE, TRUE)-loc

			attack(mob/unit/def, retaliate=1, retaliation=0)

				if(!retaliation)
					if(attacked) return
					attacked=TRUE
					displayFinished()

				world << "[owner.key]'s [name] attacks [def.owner.key]'s [def.name]"

				if(projectile) missile(projectile, src, def)

				if(prob(100*(agility/def.agility)))
					var/damage = max(attack-def.defence,1)

					if(prob(6.25*(agility/def.agility))) //1/16 chance of critting
						damage*=3

					def.takeDamage(damage, src, dtype)

				sleep(10)
				if(retaliate&&!retaliation&&def&&def.canAttack(src)) def.attack(src, 0, 1)

			takeDamage(amount, mob/unit/source, dtype)
				var/color=rgb(255,255,255)
				switch(dtype)
					if(TYPE_FIRE)
						color=rgb(255,0,0)
						amount*=(100-fireres)/100
					if(TYPE_ICE)
						amount*=(100-iceres)/100
						color=rgb(0,0,255)

				hp-=amount
				s_damage(src, amount, color)
				hp=max(0,min(hp, maxhp))

				if(hp<=0) death(source)

			death(mob/unit/source)
				del src

			reset()
				attacked=FALSE
				moved=FALSE
				if(oldicon) icon=oldicon

			displayFinished()
				if(!attacked||!moved) return
				if(!oldicon) oldicon=icon(icon)
				var/icon/i = icon(icon)
				i.Blend(rgb(64,64,64), ICON_MULTIPLY)
				icon=i

		warrior
			hp=10
			maxhp=10

			attack=5
			defence=2
			agility=10

			move=6

			fireres=0
			iceres=0

			dtype=TYPE_NORMAL
			arange=1
			icon_state="warrior"

		fire_elemental
			hp=12
			maxhp=12

			attack=7
			defence=2
			agility=20

			move=7

			fireres=150
			iceres=-50

			dtype=TYPE_FIRE
			arange=1
			icon_state="fire elemental"
			projectile = /obj/projectile/fireball

		archer
			hp=10
			maxhp=10

			attack=7
			defence=2
			agility=15

			move=6

			fireres=0
			iceres=0

			dtype=TYPE_NORMAL
			arange=5
			icon_state="archer"
			projectile = /obj/projectile/arrow

		ice_elemental
			hp=20
			maxhp=20

			attack=5
			defence=4
			agility=12

			move=5

			fireres=-50
			iceres=150

			dtype=TYPE_ICE
			arange=1
			icon_state="ice elemental"
			projectile = /obj/projectile/iceshard

		fire_wizard
			hp=7
			maxhp=7

			attack=7
			defence=0
			agility=15

			move=7

			fireres=0
			iceres=0

			dtype=TYPE_FIRE
			arange=3
			icon_state="firewizard"
			projectile = /obj/projectile/fireball

		ice_wizard
			hp=7
			maxhp=7

			attack=7
			defence=0
			agility=15

			move=7

			fireres=0
			iceres=0

			dtype=TYPE_ICE
			arange=3
			icon_state="icewizard"

			projectile = /obj/projectile/iceshard

		ice_giant
			hp=25
			maxhp=25

			attack=6
			defence=5
			agility=5

			move=4

			fireres=-50
			iceres=150

			dtype=TYPE_ICE
			arange=1
			icon_state="ice giant"

		fire_giant
			hp=15
			maxhp=15

			attack=10
			defence=3
			agility=17

			move=6

			fireres=150
			iceres=-50

			dtype=TYPE_FIRE
			arange=1
			icon_state="fire giant"

		dancing_flame
			hp=3
			maxhp=3

			attack=4
			defence=0
			agility=40

			move=9

			fireres=150
			iceres=-50

			dtype=TYPE_FIRE
			arange=1
			icon_state="dancing flame"
			density=0

		giant_wolf
			hp=15
			maxhp=15

			attack=6
			defence=3
			agility=20

			move=9

			fireres=-50
			iceres=150

			dtype=TYPE_NORMAL
			arange=1
			icon_state="wolf"